diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 823ab8f48..9901455d8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -79,7 +79,7 @@ public abstract class ScreenContainerAbstract extends Screen
 			final Slot slot1 = inventorySlots.slots.get(i);
 			boolean mouseOver = getIsMouseOverSlot(slot1, mx, my);
 			if(!itemDragHandler.isSlotDragged(slot1)) {
-				itemElement.render(slot1.getItem(), slot1.x, slot1.y, mouseOver, slot1);
+				itemElement.render(slot1.getItemStack(), slot1.x, slot1.y, mouseOver, slot1);
 			}
 			if (mouseOver)
 			{
@@ -113,7 +113,7 @@ public abstract class ScreenContainerAbstract extends Screen
 		if (inventoryplayer.getHeldItemStack() == null && slot != null && slot.hasItem())
 		{
 			boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-			String str = tooltipElement.getTooltipText(slot.getItem(), showDescription, slot);
+			String str = tooltipElement.getTooltipText(slot.getItemStack(), showDescription, slot);
 			if(str.length() > 0)
 			{
 				tooltipElement.render(str, mx, my, 8, -8);
@@ -164,7 +164,7 @@ public abstract class ScreenContainerAbstract extends Screen
 			if(mc.gameSettings.keyShowRecipe.isKeyboardKey(eventKey)){
 				Slot slot = inventorySlots.slots.get(slotId);
 				if(slot.hasItem()){
-					String query = "r:"+slot.getItem().getDisplayName()+"!";
+					String query = "r:"+slot.getItemStack().getDisplayName()+"!";
 //					removed();
 //					mc.thePlayer.closeScreen();
 					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
@@ -185,7 +185,7 @@ public abstract class ScreenContainerAbstract extends Screen
 			if(mc.gameSettings.keyShowUsage.isKeyboardKey(eventKey)){
 				Slot slot = inventorySlots.slots.get(slotId);
 				if(slot.hasItem()) {
-					String query = "u:" + slot.getItem().getDisplayName() + "!";
+					String query = "u:" + slot.getItemStack().getDisplayName() + "!";
 //					removed();
 //					mc.thePlayer.closeScreen();
 					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
@@ -292,7 +292,7 @@ public abstract class ScreenContainerAbstract extends Screen
 			// Duplicate items with middle mouse button
 			if(mouseButton == 2) {
 				Slot slot = inventorySlots.getSlot(slotId);
-				if (slot.getItem() == null) {
+				if (slot.getItemStack() == null) {
 					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slotId, 64}, mc.thePlayer);
 				} else {
 					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slotId, 64}, mc.thePlayer);
@@ -325,7 +325,7 @@ public abstract class ScreenContainerAbstract extends Screen
 		int target = 0; 
 
 		Slot slot = inventorySlots.getSlot(slotId);
-		ItemStack stackInSlot = slot != null ? slot.getItem() : null;
+		ItemStack stackInSlot = slot != null ? slot.getItemStack() : null;
 		Item itemInSlot = stackInSlot != null ? stackInSlot.getItem() : null;
 		int clickedItemId = stackInSlot != null ? stackInSlot.getItem().id : 0;
 		ItemStack grabbedItem = mc.thePlayer.inventory.getHeldItemStack();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
index 6539c502f..279951503 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/SlotGuidebook.java
@@ -12,6 +12,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 import java.util.Random;
@@ -63,7 +64,7 @@ public class SlotGuidebook extends Slot
 	}
 
 	@Override
-	public ItemStack remove(final int i)
+	public @Nullable ItemStack remove(final int i)
 	{
 		return null;
 	}
@@ -81,7 +82,7 @@ public class SlotGuidebook extends Slot
 	}
 
 	@Override
-	public ItemStack getItem()
+	public @Nullable ItemStack getItemStack()
 	{
 		return item;
 	}
@@ -97,7 +98,7 @@ public class SlotGuidebook extends Slot
     }
 
 	@Override
-	public void set(final ItemStack itemstack)
+	public void set(final @Nullable ItemStack itemstack)
 	{
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
index fd6f3d365..5e18d1e48 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
@@ -123,7 +123,7 @@ public class RecipePageCrafting
             }
             drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            itemElement.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            itemElement.render(slot.getItemStack(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
@@ -142,7 +142,7 @@ public class RecipePageCrafting
             }
             if(hoveringSlot != null){
                 if(hoveringSlot.hasItem()){
-                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
+                    String query = "r:"+hoveringSlot.getItemStack().getDisplayName()+"!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -157,7 +157,7 @@ public class RecipePageCrafting
             }
             if(hoveringSlot != null) {
                 if (hoveringSlot.hasItem()) {
-                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
+                    String query = "u:" + hoveringSlot.getItemStack().getDisplayName() + "!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -196,7 +196,7 @@ public class RecipePageCrafting
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     tooltipElement.render(str, mouseX, mouseY, 8, -8);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index 8cbb7736f..1e8f99785 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -188,7 +188,7 @@ public class GuidebookPageMob
                         drawSlot(x + 7 + (i % 7) * 21, yOffset + (i / 7) * 20, 0xFFFFFFFF);
                         GL11.glPushMatrix();
                         GL11.glTranslatef(0, 0, 50f);
-                        itemElement.render(slot.getItem(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
+                        itemElement.render(slot.getItemStack(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
                         GL11.glPopMatrix();
                         if (slot.getIsDiscovered(mc.thePlayer)) {
                             String amountString = drop.getMinAmount() == drop.getMaxAmount() ? String.valueOf(drop.getMinAmount()) : drop.getMinAmount() + "-" + drop.getMaxAmount();
@@ -278,7 +278,7 @@ public class GuidebookPageMob
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     tooltipElement.render(str, mouseX, mouseY, 8, -8);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
index 7977210aa..53acf5caa 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
@@ -78,7 +78,7 @@ public class RecipePageBlastSmelting
         for (SlotGuidebook slot : slots) {
             drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            itemElement.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            itemElement.render(slot.getItemStack(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
@@ -97,7 +97,7 @@ public class RecipePageBlastSmelting
             }
             if(hoveringSlot != null){
                 if(hoveringSlot.hasItem()){
-                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
+                    String query = "r:"+hoveringSlot.getItemStack().getDisplayName()+"!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -112,7 +112,7 @@ public class RecipePageBlastSmelting
             }
             if(hoveringSlot != null) {
                 if (hoveringSlot.hasItem()) {
-                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
+                    String query = "u:" + hoveringSlot.getItemStack().getDisplayName() + "!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -151,7 +151,7 @@ public class RecipePageBlastSmelting
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     tooltipElement.render(str, mouseX, mouseY, 8, -8);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
index 763d2cb1f..87143126e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
@@ -78,7 +78,7 @@ public class RecipePageSmelting
         for (SlotGuidebook slot : slots) {
             drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            itemElement.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            itemElement.render(slot.getItemStack(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
@@ -97,7 +97,7 @@ public class RecipePageSmelting
             }
             if(hoveringSlot != null){
                 if(hoveringSlot.hasItem()){
-                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
+                    String query = "r:"+hoveringSlot.getItemStack().getDisplayName()+"!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -112,7 +112,7 @@ public class RecipePageSmelting
             }
             if(hoveringSlot != null) {
                 if (hoveringSlot.hasItem()) {
-                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
+                    String query = "u:" + hoveringSlot.getItemStack().getDisplayName() + "!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -151,7 +151,7 @@ public class RecipePageSmelting
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     tooltipElement.render(str, mouseX, mouseY, 8, -8);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
index e5548159b..2175f4d93 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
@@ -96,7 +96,7 @@ public class RecipePageTrommel
             for (SlotGuidebook slot : slots) {
                 if (slot.recipe instanceof RecipeEntryTrommel) {
                     RecipeSymbol input = (RecipeSymbol) slot.recipe.getInput();
-                    if (!input.matches(slot.getItem())) {
+                    if (!input.matches(slot.getItemStack())) {
                         if(slot.recipeAmount > 8){
                             int recipeIndexMax = Math.round((float) slot.recipeAmount /9);
                             if(slot.recipeIndex >= recipeIndexMax){
@@ -127,7 +127,7 @@ public class RecipePageTrommel
         for (SlotGuidebook slot : slots) {
             drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            itemElement.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            itemElement.render(slot.getItemStack(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
@@ -146,7 +146,7 @@ public class RecipePageTrommel
             }
             if(hoveringSlot != null){
                 if(hoveringSlot.hasItem()){
-                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
+                    String query = "r:"+hoveringSlot.getItemStack().getDisplayName()+"!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -161,7 +161,7 @@ public class RecipePageTrommel
             }
             if(hoveringSlot != null) {
                 if (hoveringSlot.hasItem()) {
-                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
+                    String query = "u:" + hoveringSlot.getItemStack().getDisplayName() + "!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -200,7 +200,7 @@ public class RecipePageTrommel
             if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = tooltipElement.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
+                String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     tooltipElement.render(str, mouseX, mouseY, 8, -8);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 855f530a5..5ce0c784d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -21,6 +21,7 @@ import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
@@ -142,7 +143,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
         buttonReloadTextures.setActionListener(() -> mc.textureManager.refreshTexturesAndDisplayErrors());
         buttonOpenScreenshotFolder = (ListenerButtonElement) new ListenerButtonElement(30, buttonReloadTextures.getWidth() + buttonReloadTextures.getX() + 1, buttonReloadTextures.getY(), 20, 20, "")
             .setTextures("minecraft:gui/misc/button_folder", "minecraft:gui/misc/button_folder_highlighted", "minecraft:gui/misc/button_folder");
-        buttonOpenScreenshotFolder.setActionListener(() -> Utils.openDirectory(new File(mc.getMinecraftDir(), "")));
+        buttonOpenScreenshotFolder.setActionListener(() -> FileOpener.open(new File(mc.getMinecraftDir(), "")));
 
         buttonCenterScreen = new ListenerButtonElement(10, 0, 0, 120, 20, i18n.translateKey("gui.photo_mode.button.center_camera"));
         buttonCenterScreen.setActionListener(() -> {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
index f7626ed11..0aba78c6e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
@@ -8,8 +8,8 @@ import net.minecraft.client.render.window.CursorShape;
 public class FloatOptionComponent
         extends ButtonComponent
 {
-    private final OptionFloat option;
-    private final SliderElement slider;
+    protected final OptionFloat option;
+    protected final SliderElement slider;
 
     public FloatOptionComponent(OptionFloat option)
     {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
index fd86d799c..2aa7d2655 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/TooltipPickerComponent.java
@@ -1,34 +1,28 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.gui.TooltipElement;
-import net.minecraft.client.option.OptionToggleable;
-import net.minecraft.client.option.enums.TooltipStyle;
+import net.minecraft.client.option.OptionTooltip;
 import net.minecraft.client.render.window.CursorShape;
 import org.lwjgl.opengl.GL11;
 
-public class TooltipPickerComponent<E>
-    extends ToggleableOptionComponent<E> {
+public class TooltipPickerComponent
+    extends ToggleableOptionComponent<String> {
 
     private final TooltipElement tooltip;
 
-    public TooltipPickerComponent(OptionToggleable<E> option) {
+    public TooltipPickerComponent(final OptionTooltip option) {
         super(option);
 
         this.tooltip = new TooltipElement(mc);
     }
 
     @Override
-    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
+    protected void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
         super.renderButton(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
 
-        int stringWidth = mc.font.getStringWidth(this.option.getDisplayStringValue());
-        int padding = 3;
-        int yOffset = 0;
-        if (this.option.value != TooltipStyle.DEFAULT) {
-            padding++;
-            yOffset = -1;
-        }
-        stringWidth += padding * 2;
+        final int padding = 3;
+        final int yOffset = 0;
+        final int stringWidth = mc.font.getStringWidth(this.option.getDisplayStringValue()) + padding * 2;
         GL11.glColor4f(1, 1, 1, 1);
         this.tooltip.render(this.option.getDisplayStringValue(), x + relativeButtonX + buttonWidth / 2 - stringWidth / 2, y + relativeButtonY + 3 + yOffset, 0, 0);
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 0a474d34d..c2392c95d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -10,8 +10,10 @@ import net.minecraft.client.gui.ScreenTextureViewer;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.options.components.*;
+import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.client.sound.SoundEngine;
+import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.Stat;
@@ -66,7 +68,7 @@ public abstract class OptionsPages
                 .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayScreen(new ScreenHudDesigner(mc.currentScreen))))
                 .withComponent(new IntegerOptionComponent(mc.gameSettings.guiScale))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.screenPadding))
-                .withComponent(new TooltipPickerComponent<>(mc.gameSettings.tooltipStyle))
+                .withComponent(new TooltipPickerComponent(mc.gameSettings.tooltipStyle))
                 .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.chatVisibility))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.fpsInOverlay))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.versionInOverlay))
@@ -84,12 +86,12 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.forceUnicodeFont))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.autosaveTimer))
             )
-            .withComponent(new ShortcutComponent("gui.options.page.general.button.open_worlds_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "saves"))))
+            .withComponent(new ShortcutComponent("gui.options.page.general.button.open_worlds_folder", () -> FileOpener.open(new File(mc.getMinecraftDir(), "saves"))))
             .withComponent(new ShortcutComponent("gui.options.page.general.button.open_screenshots_folder", () -> {
                 final File f = new File(mc.getMinecraftDir(), "screenshots");
                 //noinspection ResultOfMethodCallIgnored
                 f.mkdirs();
-                Utils.openDirectory(f);
+                FileOpener.open(f);
             }))
         );
 
@@ -148,7 +150,13 @@ public abstract class OptionsPages
             )
             .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
                 .withComponent(Minecraft.GPU_VENDOR == EnumGPUVendor.INTEL ? null : lightmapComponent)
-                .withComponent(new FloatOptionComponent(mc.gameSettings.brightness))
+                .withComponent(new FloatOptionComponent(mc.gameSettings.brightness){
+                    @Override
+                    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                        this.slider.enabled = mc.gameSettings.lightmapStyle.value != LightmapStyle.DISABLED;
+                        super.render(x, y, width, relativeMouseX, relativeMouseY);
+                    }
+                })
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.fovModification))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.screenMotionEffects))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.fog))
@@ -269,7 +277,7 @@ public abstract class OptionsPages
         );
 
         TEXTURE_PACKS = register(new OptionsPage("gui.options.page.texture_packs.title", new ItemStack(Items.PAINTING))
-            .withComponent(new ShortcutComponent("gui.options.page.texture_packs.button.open_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "texturepacks"))))
+            .withComponent(new ShortcutComponent("gui.options.page.texture_packs.button.open_folder", () -> FileOpener.open(new File(mc.getMinecraftDir(), "texturepacks"))))
             .withComponent(new OptionsCategory("gui.options.page.texture_packs.category.textures")
                 .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.animations))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.customAnimations))
@@ -286,7 +294,7 @@ public abstract class OptionsPages
             )
         );
         LANGUAGE = register(new OptionsPage("gui.options.page.language_packs.title", new ItemStack(Items.BOOK))
-            .withComponent(new ShortcutComponent("gui.options.page.language_packs.button.open_folder", () -> Utils.openDirectory(new File(mc.getMinecraftDir(), "languages"))))
+            .withComponent(new ShortcutComponent("gui.options.page.language_packs.button.open_folder", () -> FileOpener.open(new File(mc.getMinecraftDir(), "languages"))))
             .withComponent(new OptionsCategory("gui.options.page.language_packs.category.language_packs")
                 .withComponent(new LanguagePackListComponent())
             )
@@ -353,7 +361,7 @@ public abstract class OptionsPages
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
                     DataDumper.main(new String[0]);
-                    Utils.openDirectory(new File(mc.getMinecraftDir(), "infodump"));
+                    FileOpener.open(new File(mc.getMinecraftDir(), "infodump"));
                     Global.accessor = mc;
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.achievements", () -> mc.displayScreen(new ScreenAchievements(mc.currentScreen, mc.statsCounter))))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java b/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
index 5e9722250..e40966600 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
@@ -1,6 +1,9 @@
 package net.minecraft.client.gui.text;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.Global;
+import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.core.util.helper.MathHelper;
@@ -264,9 +267,7 @@ public class TextFieldEditor
     {
         try
         {
-            StringSelection selection = new StringSelection(string);
-            Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
-            clipboard.setContents(selection, selection);
+            Global.accessor.copyToClipboard(string);
         }
         catch (Exception e)
         {
@@ -278,11 +279,7 @@ public class TextFieldEditor
     {
         try
         {
-            Transferable trans = Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null);
-            if (trans != null && trans.isDataFlavorSupported(DataFlavor.stringFlavor))
-            {
-                return (String) trans.getTransferData(DataFlavor.stringFlavor);
-            }
+            return Global.accessor.readFromClipboard();
         }
         catch (Exception e)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java
index bfa2ae7d6..d37ea7cf3 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerInventoryHandler.java
@@ -24,7 +24,7 @@ public class ControllerInventoryHandler {
 		
 		if(controllerInput.buttonA.pressedThisFrame()) {
 			for(Slot slot2 : container.inventorySlots.slots) {
-                LOGGER.debug("{}: {}", slot2.index, slot2.getItem());
+                LOGGER.debug("{}: {}", slot2.index, slot2.getItemStack());
 			}
 		}
 		
